## unity-notifications 0.1.0daily13.06.20

=== CMakeLists.txt ===
project(notification-server C CXX)
cmake_minimum_required(VERSION 2.8.9)

set(SONAME 1)
set(VERSION 1.0)
set(SOVERSION 1.0.0)

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

option(basic_warnings "Basic compiler warnings." ON)
option(build_tools "Build developer tools." OFF)
option(private_dbus "Use private dbus namespace to prevent clashes during development." OFF)

include(FindPkgConfig)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++0x")
add_definitions(-DQT_NO_KEYWORDS)

if(${basic_warnings})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
endif()

set(LIBDIR "lib" CACHE PATH "Destination install dir for the library")

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5Widgets REQUIRED)
# Workaround for https://bugreports.qt-project.org/browse/QTBUG-29987
set(QT_IMPORTS_DIR "${LIBDIR}/qt5/qml")

include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
add_subdirectory(include)
add_subdirectory(src)
if(${build_tools})
  add_subdirectory(tools)
endif()

# Disabled this until trunks of both Unity and notifications
# have been updated to work together.

##find_program(qmltestrunner_exe qmltestrunner)
##
##if(NOT qmltestrunner_exe)
##  message(FATAL_ERROR "Could not locate qmltestrunner.")
##endif()
##
##macro(add_qml_test COMPONENT_NAME)
##    set(options NO_ADD_TEST NO_TARGETS)
##
##    cmake_parse_arguments(qmltest "${options}" "IMPORT_PATH" "TARGETS" ${ARGN})
##
##    set(qmltest_TARGET test${COMPONENT_NAME})
##    set(qmltest_FILE tst_${COMPONENT_NAME})
##
##    if("${qmltest_IMPORT_PATH}" STREQUAL "")
##        add_custom_target(${qmltest_TARGET}
##            ${qmltestrunner_exe}  -input ${CMAKE_CURRENT_SOURCE_DIR}/${qmltest_FILE}.qml
##                          -o ${CMAKE_BINARY_DIR}/${qmltest_TARGET}.xml,xunitxml
##                          -o -,txt)
##    else()
##        add_custom_target(${qmltest_TARGET}
##            ${qmltestrunner_exe} -input ${CMAKE_CURRENT_SOURCE_DIR}/${qmltest_FILE}.qml
##                          -import ${qmltest_IMPORT_PATH}
##                          -o ${CMAKE_BINARY_DIR}/${qmltest_TARGET}.xml,xunitxml
##                          -o -,txt)
##    endif()
##
##    if(NOT "${qmltest_UNPARSED_ARGUMENTS}" STREQUAL "")
##        set_target_properties(${qmltest_TARGET} ${qmltest_PROPERTIES})
##    elseif(NOT "${qmltest_DEFAULT_PROPERTIES}" STREQUAL "")
##        set_target_properties(${qmltest_TARGET} ${qmltest_DEFAULT_PROPERTIES})
##    endif()
##
##    if("${qmltest_NO_ADD_TEST}" STREQUAL FALSE AND NOT "${qmltest_DEFAULT_NO_ADD_TEST}" STREQUAL "TRUE")
##        add_test(${qmltest_TARGET} make ${qmltest_TARGET})
##
##        if(NOT "${qmltest_UNPARSED_ARGUMENTS}" STREQUAL "")
##            set_tests_properties(${qmltest_TARGET} ${qmltest_PROPERTIES})
##        elseif(NOT "${qmltest_DEFAULT_PROPERTIES}" STREQUAL "")
##            set_tests_properties(${qmltest_TARGET} ${qmltest_DEFAULT_PROPERTIES})
##        endif()
##    endif("${qmltest_NO_ADD_TEST}" STREQUAL FALSE AND NOT "${qmltest_DEFAULT_NO_ADD_TEST}" STREQUAL "TRUE")
##
##    if("${qmltest_NO_TARGETS}" STREQUAL "FALSE")
##        if(NOT "${qmltest_TARGETS}" STREQUAL "")
##            foreach(TARGET ${qmltest_TARGETS})
##                add_dependencies(${TARGET} ${qmltest_TARGET})
##            endforeach(TARGET)
##        elseif(NOT "${qmltest_DEFAULT_TARGETS}" STREQUAL "")
##            foreach(TARGET ${qmltest_DEFAULT_TARGETS})
##                add_dependencies(${TARGET} ${qmltest_TARGET})
##            endforeach(TARGET)
##        endif()
##    endif("${qmltest_NO_TARGETS}" STREQUAL "FALSE")
##endmacro()

enable_testing()
add_subdirectory(test)

## unity-notifications 0.1.1+13.10.20131004.2-0ubuntu1

=== debian/changelog ===
unity-notifications (0.1.1+13.10.20131004.2-0ubuntu1) saucy; urgency=low

  * Revert 0.1.1+13.10.20131004.1-0ubuntu1 to 0.1.0+13.10.20130905.2-0ubuntu1
    as unity8 is getting revert due to a CPU hogging bug.

 -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 04 Oct 2013 21:25:48 +0200

unity-notifications (0.1.1+13.10.20131004.1-0ubuntu1) saucy; urgency=low

  [ Michał Sawicz ]
  * Bump version to indicate support for passing hints through.
  * Look for *any* slashes, not just a leading one, to support URLs.
    Also drop an outdated FIXME. (LP: #1224095)

  [ Mirco Müller ]
  * Added support for new hints "x-canonical-private-menu-model" and "x-
    canonical-ext-snap-decisions" allowing to pass in UnityMenuModel UI-
    descriptions and enable extended snap-decisions.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 175

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 04 Oct 2013 06:55:02 +0000

unity-notifications (0.1.0+13.10.20130905.2-0ubuntu1) saucy; urgency=low

  [ Jussi Pakkanen ]
  * Remove stray "lesser" qualifiers from license link text.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 171

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 05 Sep 2013 10:47:48 +0000

unity-notifications (0.1.0+13.10.20130801-0ubuntu1) saucy; urgency=low

  * Automatic snapshot from revision 169

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 01 Aug 2013 14:30:21 +0000

unity-notifications (0.1.0+13.10.20130703ubuntu.unity.next-0ubuntu1) saucy; urgency=low

  [ Francis Ginther ]
  * Added coverage targets.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 168 (ubuntu-unity/next)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 03 Jul 2013 02:35:04 +0000

unity-notifications (0.1.0+13.10.20130702ubuntu.unity.next-0ubuntu1) saucy; urgency=low

  [ Mirco Müller ]
  * The frontend no longer needs ActionModel::actionId(), so to keep the
    backend's API cleaner actionId() was removed.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 166 (ubuntu-unity/next)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 02 Jul 2013 02:31:06 +0000

unity-notifications (0.1.0+13.10.20130628ubuntu.unity.next-0ubuntu1) saucy; urgency=low

  [ Didier Roche ]
  * More modern multiarch support.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 164 (ubuntu-unity/next)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 28 Jun 2013 02:31:04 +0000

unity-notifications (0.1.0+13.10.20130627ubuntu.unity.next-0ubuntu1) saucy; urgency=low

  * Automatic snapshot from revision 162 (ubuntu-unity/next)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 27 Jun 2013 09:48:55 +0000

unity-notifications (0.1.0daily13.06.20-0ubuntu1) saucy; urgency=low

  [ Jussi Pakkanen ]
  * Initial release.
  * Started work on the notification backend.
  * Skeleton classes for the system.
  * Private structs for objects.
  * Some work in the renderer.
  * Can insert notifications.
  * Can delete notifications from the store.
  * One header for common definitions.
  * Added ID number to Notification.
  * Keep notifications in order in the stack.
  * Check that renderer is called.
  * Removed check by pointer.
  * CMake harness for Qt5.
  * Can display string list. Hoo ray.
  * Created own model.
  * Model works, even.
  * Data flows between model and view.
  * Insert and delete operations.
  * Can add and remove items from the model and the view is updated.
  * Insert at the beginning.
  * Can instantiate a window from a ui file.
  * Generate UI files properly.
  * Moved to multiple inheritance model.
  * Can connect signals.
  * Button can be used to invoke segfaults. Which is a problem because
    it should invoke data insertion.
  * Notifications have identifying strings in them.
  * Added type to Notification class.
  * Insert notification objects into model.
  * Notifications expire on timeouts.
  * Non-visible notifications are queued.
  * Can send synchronous notifications and they take precedence.
  * Switched to smart pointers for great non-memory-leaking justice!
  * Interactive notifications are queued and dequeued properly.
  * Can send snap decisions.
  * Snap decisions are put in and queued properly.
  * Can send notifications of different type.
  * Take display time from Notification objects.
  * Track time already spent showing each notification.
  * Confucious say: one bad comparison operator cause massive bughunt.
  * Keep input queues sorted according to importance.
  * Changed header suffix to .h.
  * Added two files that I accidentally moved with "mv <filename>
    <filename>" instead of "bzr mv <filename> <filename>".
  * Function renaming.
  * Priority for async notifications.
  * Interactive notifications have priorities.
  * Proper compare function for qStableSort.
  * Snap decisions have priority too.
  * Find proper place to put snap decisions, since there may be several
    of them.
  * Made Notification a QObject so it can be exposed to QML.
  * Default constructor for QML.
  * Can create a Qml view.
  * Can expose Notification objects to Qml.
  * Make Notification owned by a shared pointer.
  * Snap decisions override everything else.
  * Added function to remove notifications from the model.
  * Expose notificationmodel to Qml.
  * Started work on DBus service.
  * Start work on dbus service tool.
  * Register service name. Also not crash.
  * Added capabilities.
  * Renamed dbus server.
  * Added client test application.
  * Tried to make the dbus communication work. Unsuccessfully.
  * It workses!
  * Capabilities travel through dbus.
  * More interface exposing.
  * Reply signals.
  * Expose the entire DBus API in correct form.
  * Started work on proper notification client test app.
  * Added slots for signal invocation.
  * (Try to) connect to dbus signal.
  * Working to get the signals going. Thus far unsuccessfully.


=== debian/control ===
Source: unity-notifications
Section: libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9~),
               cmake,
               pkg-config,
               qtdeclarative5-dev,
               qtbase5-dev-tools,
# For Qml tests
               qtchooser,
               qt5-default,
               qtdeclarative5-dev-tools,
               qtdeclarative5-test-plugin,
               qtdeclarative5-qtquick2-plugin,
Standards-Version: 3.9.4

Package: qtdeclarative5-unity-notifications-plugin
Provides: unity-notifications-impl,
          unity-notifications-impl-1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: Unity Notifications - shared library
 This package provides an interface and implementation of desktop notifications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@ --parallel --fail-missing

override_dh_auto_configure:
	# we already defines the flags through dpkg-buildflags, we don't need
	# thus to use relwithdebinfo, which is defining -DNDEBUG which are
	# breaking the tests
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=''

## unity-notifications 0.1.1+13.10.20131011.2

=== src/CMakeLists.txt ===
set(CORE_SRCS
ActionModel.cpp
../include/ActionModel.h
Notification.cpp
../include/Notification.h
NotificationModel.cpp
../include/NotificationModel.h
NotificationServer.cpp
../include/NotificationServer.h
NotificationClient.cpp
../include/NotificationClient.h
)

# Build everything twice. Since we have only a few
# source files, this is not an issue. If it does
# become one, change tools so they use the plugin
# instead of calling the classes directly.

add_library(notifybackend SHARED
${CORE_SRCS}
)

add_library(notifyplugin MODULE
${CORE_SRCS}
NotificationPlugin.cpp
../include/NotificationPlugin.h
)

set_target_properties(notifyplugin PROPERTIES
  SOVERSION ${SONAME}
  VERSION ${SOVERSION}
  )

add_library(notifyclientplugin MODULE
NotificationClientPlugin.cpp
../include/NotificationClientPlugin.h
NotificationClient.cpp
../include/NotificationClient.h
)

set_target_properties(notifyclientplugin PROPERTIES
  SOVERSION ${SONAME}
  VERSION ${SOVERSION}
  )

qt5_use_modules(notifybackend Widgets DBus Qml)
qt5_use_modules(notifyplugin Widgets DBus Qml)
qt5_use_modules(notifyclientplugin Widgets DBus Qml)

install(
  TARGETS notifyplugin notifyclientplugin
  ARCHIVE DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
  LIBRARY DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
)

install(FILES qmldir
  DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
)

=== test/CMakeLists.txt ===
add_executable(notificationtest notificationtest.cpp)
target_link_libraries(notificationtest notifybackend)
qt5_use_modules(notificationtest Gui Core Widgets)

add_test(notification notificationtest)
set_tests_properties(notification PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

# Disabled until frontend and backend are fully
# merged to respective trunks.
#add_qml_test(NotificationInterface)

## unity-notifications 0.1.1+13.10.20131015

=== tools/CMakeLists.txt ===
qt5_wrap_ui(GUI_HEADERS mainWindow.ui serverMainWindow.ui clientMainWindow.ui)

add_executable(viewer
viewer.cpp
mainWindow.cpp
mainWindow.h
${GUI_HEADERS}
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt5_use_modules(viewer Widgets)
target_link_libraries(viewer notifybackend)

add_executable(qmltest qmltest.cpp)

qt5_use_modules(qmltest Qml Quick DBus Widgets)
target_link_libraries(qmltest notifybackend)

add_executable(dbusserver dbusserver.cpp serverMainWindow.cpp)
qt5_use_modules(dbusserver Widgets DBus)
target_link_libraries(dbusserver notifybackend)

add_executable(dbusclient dbusclient.cpp clientMainWindow.cpp)
qt5_use_modules(dbusclient Widgets DBus)
target_link_libraries(dbusclient notifybackend)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Notifications
    DESTINATION ${CMAKE_BINARY_DIR}/tools
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/datatest.qml
    DESTINATION ${CMAKE_BINARY_DIR}/tools
)

## unity-notifications 0.1.1+14.04.20140402

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,9 @@
 option(build_tools "Build developer tools." OFF)
 option(private_dbus "Use private dbus namespace to prevent clashes during development." OFF)
 
+include(cmake/coverage.cmake)
 include(FindPkgConfig)
+include (GNUInstallDirs)
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++0x")
 add_definitions(-DQT_NO_KEYWORDS)
@@ -23,14 +25,12 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
 endif()
 
-set(LIBDIR "lib" CACHE PATH "Destination install dir for the library")
-
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 find_package(Qt5Widgets REQUIRED)
 # Workaround for https://bugreports.qt-project.org/browse/QTBUG-29987
-set(QT_IMPORTS_DIR "${LIBDIR}/qt5/qml")
+set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
 
 include_directories(include)
 include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -47,12 +47,22 @@
 qt5_use_modules(notifyplugin Widgets DBus Qml)
 qt5_use_modules(notifyclientplugin Widgets DBus Qml)
 
+execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix unity-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(SHELL_INSTALL_QML STREQUAL "")
+    message(FATAL_ERROR "Could not determine plugin installation dir.")
+endif()
+ 
+execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir unity-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(SHELL_PLUGINDIR STREQUAL "")
+    message(FATAL_ERROR "Could not determine plugin import dir.")
+endif()
+
 install(
   TARGETS notifyplugin notifyclientplugin
-  ARCHIVE DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
-  LIBRARY DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
+  ARCHIVE DESTINATION ${SHELL_PLUGINDIR}/Unity/Notifications
+  LIBRARY DESTINATION ${SHELL_PLUGINDIR}/Unity/Notifications
 )
 
 install(FILES qmldir
-  DESTINATION ${QT_IMPORTS_DIR}/Unity/Notifications.${SONAME}
+  DESTINATION ${SHELL_INSTALL_QML}/Unity/Notifications
 )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 add_executable(notificationtest notificationtest.cpp)
 target_link_libraries(notificationtest notifybackend)
-qt5_use_modules(notificationtest Gui Core Widgets)
+qt5_use_modules(notificationtest Gui Test Core Widgets)
 
 add_test(notification notificationtest)
 set_tests_properties(notification PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

## unity-notifications 0.1.2+14.10.20140922

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+include(FindPkgConfig)
+pkg_check_modules(NOTIFICATIONS_API REQUIRED unity-shell-notifications=3)
+
 set(CORE_SRCS
 ActionModel.cpp
 ../include/ActionModel.h
@@ -9,6 +12,7 @@
 ../include/NotificationServer.h
 NotificationClient.cpp
 ../include/NotificationClient.h
+${NOTIFICATIONS_API_INCLUDEDIR}/unity/shell/notifications/ModelInterface.h
 )
 
 # Build everything twice. Since we have only a few

## unity-notifications 0.1.2+15.10.20150623.is.0.1.2+15.10.20150804

=== test/CMakeLists.txt ===

function(add_notification_test NAME)
    add_executable(${NAME} "${NAME}.cpp")

    target_link_libraries(${NAME}
        notifybackend
        ${QTDBUSTEST_LDFLAGS}
    )

    qt5_use_modules(${NAME}
        Core
        DBus
        Gui
        Qml
        Test
        Widgets
    )

    add_test(${NAME} ${NAME})

    set_tests_properties(${NAME} PROPERTIES
        ENVIRONMENT "QT_QPA_PLATFORM=minimal"
    )
endfunction()

pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1 REQUIRED)
include_directories(${QTDBUSTEST_INCLUDE_DIRS})

set(DBUS_SERVER_BINARY "${CMAKE_BINARY_DIR}/tools/dbusserver")
add_definitions(-DDBUS_SERVER_BINARY="${DBUS_SERVER_BINARY}")

add_notification_test(notificationtest)
add_notification_test(notificationservertest)

# Disabled until frontend and backend are fully
# merged to respective trunks.
#add_qml_test(NotificationInterface)

## unity-notifications 0.1.3+15.10.20151021

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,14 +10,13 @@
 endif()
 
 option(basic_warnings "Basic compiler warnings." ON)
-option(build_tools "Build developer tools." OFF)
 option(private_dbus "Use private dbus namespace to prevent clashes during development." OFF)
 
 include(cmake/coverage.cmake)
 include(FindPkgConfig)
 include (GNUInstallDirs)
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++0x")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11")
 add_definitions(-DQT_NO_KEYWORDS)
 
 if(${basic_warnings})
@@ -28,17 +27,26 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
+find_package(Qt5Core REQUIRED)
+include_directories(${Qt5Core_INCLUDE_DIRS})
+
+find_package(Qt5DBus REQUIRED)
+include_directories(${Qt5DBus_INCLUDE_DIRS})
+
 find_package(Qt5Widgets REQUIRED)
+include_directories(${Qt5Widgets_INCLUDE_DIRS})
+
 # Workaround for https://bugreports.qt-project.org/browse/QTBUG-29987
 set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
 
-include_directories(include)
-include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
+include_directories("include")
+include_directories("${CMAKE_BINARY_DIR}/include")
+include_directories("src")
+include_directories("${CMAKE_BINARY_DIR}/src")
+
 add_subdirectory(include)
 add_subdirectory(src)
-if(${build_tools})
-  add_subdirectory(tools)
-endif()
+add_subdirectory(tools)
 
 # Disabled this until trunks of both Unity and notifications
 # have been updated to work together.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,8 @@
 set(CORE_SRCS
 ActionModel.cpp
 ../include/ActionModel.h
+DBusTypes.cpp
+../include/DBusTypes.h
 Notification.cpp
 ../include/Notification.h
 NotificationModel.cpp
@@ -15,17 +17,32 @@
 ${NOTIFICATIONS_API_INCLUDEDIR}/unity/shell/notifications/ModelInterface.h
 )
 
-# Build everything twice. Since we have only a few
-# source files, this is not an issue. If it does
-# become one, change tools so they use the plugin
-# instead of calling the classes directly.
+set_source_files_properties(
+    "org.freedesktop.Notifications.xml"
+    PROPERTIES
+    NO_NAMESPACE YES
+    INCLUDE "DBusTypes.h"
+)
 
-add_library(notifybackend SHARED
+qt5_add_dbus_adaptor(
+    CORE_SRCS
+    "org.freedesktop.Notifications.xml"
+    NotificationServer.h
+    NotificationServer
+    NotificationsAdaptor
+)
+
+qt5_add_dbus_interface(
+    CORE_SRCS
+    "org.freedesktop.Notifications.xml"
+    NotificationsInterface
+)
+
+add_library(notifybackend STATIC
 ${CORE_SRCS}
 )
 
 add_library(notifyplugin MODULE
-${CORE_SRCS}
 NotificationPlugin.cpp
 ../include/NotificationPlugin.h
 )
@@ -33,7 +50,12 @@
 set_target_properties(notifyplugin PROPERTIES
   SOVERSION ${SONAME}
   VERSION ${SOVERSION}
-  )
+)
+
+target_link_libraries(
+  notifyplugin
+  notifybackend
+)
 
 add_library(notifyclientplugin MODULE
 NotificationClientPlugin.cpp
@@ -45,11 +67,14 @@
 set_target_properties(notifyclientplugin PROPERTIES
   SOVERSION ${SONAME}
   VERSION ${SOVERSION}
-  )
+)
+
+target_link_libraries(
+  notifyclientplugin
+  notifybackend
+)
 
 qt5_use_modules(notifybackend Widgets DBus Qml)
-qt5_use_modules(notifyplugin Widgets DBus Qml)
-qt5_use_modules(notifyclientplugin Widgets DBus Qml)
 
 execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix unity-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
 if(SHELL_INSTALL_QML STREQUAL "")

## unity-notifications 0.1.3+16.10.20160809

=== CMakeLists.txt ===
pkg_check_modules(NOTIFICATIONS_API REQUIRED unity-shell-notifications=3)

set(CORE_SRCS
ActionModel.cpp
../include/ActionModel.h
DBusTypes.cpp
../include/DBusTypes.h
Notification.cpp
../include/Notification.h
NotificationModel.cpp
../include/NotificationModel.h
NotificationServer.cpp
../include/NotificationServer.h
NotificationClient.cpp
../include/NotificationClient.h
${NOTIFICATIONS_API_INCLUDEDIR}/unity/shell/notifications/ModelInterface.h
)

set_source_files_properties(
    "org.freedesktop.Notifications.xml"
    PROPERTIES
    NO_NAMESPACE YES
    INCLUDE "DBusTypes.h"
)

qt5_add_dbus_adaptor(
    CORE_SRCS
    "org.freedesktop.Notifications.xml"
    NotificationServer.h
    NotificationServer
    NotificationsAdaptor
)

qt5_add_dbus_interface(
    CORE_SRCS
    "org.freedesktop.Notifications.xml"
    NotificationsInterface
)

add_library(notifybackend STATIC
${CORE_SRCS}
)

add_library(notifyplugin MODULE
NotificationPlugin.cpp
../include/NotificationPlugin.h
)

set_target_properties(notifyplugin PROPERTIES
  SOVERSION ${SONAME}
  VERSION ${SOVERSION}
)

target_link_libraries(
  notifyplugin
  notifybackend
)

add_library(notifyclientplugin MODULE
NotificationClientPlugin.cpp
../include/NotificationClientPlugin.h
NotificationClient.cpp
../include/NotificationClient.h
)

set_target_properties(notifyclientplugin PROPERTIES
  SOVERSION ${SONAME}
  VERSION ${SOVERSION}
)

target_link_libraries(
  notifyclientplugin
  notifybackend
)

qt5_use_modules(notifybackend Widgets DBus Qml)

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix unity-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_INSTALL_QML STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin installation dir.")
endif()
 
execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir unity-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin import dir.")
endif()

install(
  TARGETS notifyplugin notifyclientplugin
  ARCHIVE DESTINATION ${SHELL_PLUGINDIR}/Unity/Notifications
  LIBRARY DESTINATION ${SHELL_PLUGINDIR}/Unity/Notifications
)

install(FILES qmldir
  DESTINATION ${SHELL_INSTALL_QML}/Unity/Notifications
)
